#include <machine/asmacros.h>

/*
 * void my_outs(int port, int offset, int count, int countdown, int direction,
		int size)
 */
ENTRY(my_outs)
	push	%ebp
	mov	%esp, %ebp
	push	%esi			/* callee saved */

	mov	0x8(%ebp), %edx		/* %edx = port */
	mov	0xc(%ebp), %esi		/* %esi = string address */
	mov	0x10(%ebp), %ecx	/* %ecx = count */
	mov	0x14(%ebp), %eax	/* %eax = countdown */

	cmpl	$1, %eax		/* if (countdown == 1) */
	je	1f
	cld				/* DF = 0 (countup) */
	jmp	2f
1:
	std				/* DF = 1 (countdown) */
2:
	mov	0x18(%ebp), %eax	/* %eax = size */
	cmpl	$1, %eax		/* outsb */
	je	4f

	cmpl	$2, %eax		/* outsw */
	je	3f

	.byte 0x65			/* outsl */
	rep outsl
	jmp	5f
3:
	.byte 0x65
	rep outsw
	jmp	5f
4:
	.byte 0x65			/* %gs: segment override prefix */
	rep outsb
5:
	pop	%esi
	pop	%ebp
	ret
END(my_outs)

/*
 * void my_insb(int port, int offset, int count)
 */
ENTRY(my_insb)
	push	%ebp
	mov	%esp, %ebp
	push	%edi			/* callee saved */

	mov	0x8(%ebp), %edx		/* %edx = port */
	mov	0xc(%ebp), %edi		/* %edi = string address */
	mov	0x10(%ebp), %ecx	/* %ecx = count */

	cld
	rep insb

	pop	%edi
	pop	%ebp
	ret
END(my_insb)
